
#include <windows.h>  
#include "CrtClrSp.h" 


#if defined (WIN32)
	#define IS_WIN32 TRUE
#else
	#define IS_WIN32 FALSE
#endif

#define IS_NT      IS_WIN32 && (BOOL)(GetVersion() < 0x80000000)
#define IS_WIN32S  IS_WIN32 && (BOOL)(!(IS_NT) && (LOBYTE(LOWORD(GetVersion()))<4))
#define IS_WIN95   (BOOL)(!(IS_NT) && !(IS_WIN32S)) && IS_WIN32

HINSTANCE hInst;   // current instance

LPCTSTR lpszAppName  = "MyApp";
LPCTSTR lpszTitle    = "My Application"; 

BOOL RegisterWin95( CONST WNDCLASS* lpwc );

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
                      LPTSTR lpCmdLine, int nCmdShow)
{
   MSG      msg;
   HWND     hWnd; 
   WNDCLASS wc;

   // Register the main application window class.
   //............................................
   wc.style         = CS_HREDRAW | CS_VREDRAW;
   wc.lpfnWndProc   = (WNDPROC)WndProc;       
   wc.cbClsExtra    = 0;                      
   wc.cbWndExtra    = 0;                      
   wc.hInstance     = hInstance;              
   wc.hIcon         = LoadIcon( hInstance, lpszAppName ); 
   wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
   wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
   wc.lpszMenuName  = lpszAppName;              
   wc.lpszClassName = lpszAppName;              

   if ( IS_WIN95 )
   {
      if ( !RegisterWin95( &wc ) )
         return( FALSE );
   }
   else if ( !RegisterClass( &wc ) )
      return( FALSE );

   hInst = hInstance; 

   // Create the main application window.
   //....................................
   hWnd = CreateWindow( lpszAppName, 
                        lpszTitle,    
                        WS_OVERLAPPEDWINDOW, 
                        CW_USEDEFAULT, 0, 
                        CW_USEDEFAULT, 0,  
                        NULL,              
                        NULL,              
                        hInstance,         
                        NULL               
                      );

   if ( !hWnd ) 
      return( FALSE );

   ShowWindow( hWnd, nCmdShow ); 
   UpdateWindow( hWnd );         

   while( GetMessage( &msg, NULL, 0, 0) )   
   {
      TranslateMessage( &msg ); 
      DispatchMessage( &msg );  
   }

   return( msg.wParam ); 
}


BOOL RegisterWin95( CONST WNDCLASS* lpwc )
{
   WNDCLASSEX wcex;

   wcex.style         = lpwc->style;
   wcex.lpfnWndProc   = lpwc->lpfnWndProc;
   wcex.cbClsExtra    = lpwc->cbClsExtra;
   wcex.cbWndExtra    = lpwc->cbWndExtra;
   wcex.hInstance     = lpwc->hInstance;
   wcex.hIcon         = lpwc->hIcon;
   wcex.hCursor       = lpwc->hCursor;
   wcex.hbrBackground = lpwc->hbrBackground;
   wcex.lpszMenuName  = lpwc->lpszMenuName;
   wcex.lpszClassName = lpwc->lpszClassName;

   // Added elements for Windows 95.
   //...............................
   wcex.cbSize = sizeof(WNDCLASSEX);
   wcex.hIconSm = LoadImage(wcex.hInstance, lpwc->lpszClassName, 
                            IMAGE_ICON, 16, 16,
                            LR_DEFAULTCOLOR );
			
   return RegisterClassEx( &wcex );
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam )
{
   switch( uMsg )
   {
      case WM_COMMAND :
              switch( LOWORD( wParam ) )
              {
                 case IDM_TEST :
                        {
                           LOGCOLORSPACE ColorSpace;
                           HCOLORSPACE   hColorSpace;
                           HBRUSH        hBrush, hOldBrush;
                           HDC hDC = GetDC( hWnd );

                           // Fill LOGCOLORSPACE structure with 
                           // appropriate values.
                           //..................................
                           ColorSpace.lcsSignature= (DWORD)0x50534F43;
                           ColorSpace.lcsVersion  = 0x00000400;
                           ColorSpace.lcsSize     = sizeof( ColorSpace );
                           ColorSpace.lcsCSType   = LCS_DEVICE_RGB;
                           ColorSpace.lcsIntent   = LCS_GM_BUSINESS;

                           ColorSpace.lcsGammaRed   = 0x00010000;
                           ColorSpace.lcsGammaGreen = 0x00010000;
                           ColorSpace.lcsGammaBlue  = 0x00010000;

                           ColorSpace.lcsEndpoints.ciexyzRed.ciexyzX = 0x000051FB;
                           ColorSpace.lcsEndpoints.ciexyzRed.ciexyzY = 0x000051EB;
                           ColorSpace.lcsEndpoints.ciexyzRed.ciexyzZ = 0x00002B85;

                           ColorSpace.lcsEndpoints.ciexyzGreen.ciexyzX = 0x0000186F;
                           ColorSpace.lcsEndpoints.ciexyzGreen.ciexyzY = 0x0000552D;
                           ColorSpace.lcsEndpoints.ciexyzGreen.ciexyzZ = 0x0000BA23;

                           ColorSpace.lcsEndpoints.ciexyzBlue.ciexyzX = 0x00011693;
                           ColorSpace.lcsEndpoints.ciexyzBlue.ciexyzY = 0x00003D46;
                           ColorSpace.lcsEndpoints.ciexyzBlue.ciexyzZ = 0x00001DED;

                           ColorSpace.lcsFilename[0] = 0;

                           // Create the color space and blue brush.
                           //.......................................
                           hColorSpace = CreateColorSpace( &ColorSpace );
                           hBrush      = CreateSolidBrush( RGB( 0, 0, 255 ) );

                           // Select the blue brush into the device context.
                           //...............................................
                           hOldBrush = SelectObject( hDC, hBrush );

                           // Draw a blue rectangle.
                           //.......................
                           Rectangle( hDC, 10, 10, 50, 50 );

                           // Enable image color matching and 
                           // set the color space.
                           //................................
                           SetICMMode( hDC, ICM_ON );
                           SetColorSpace( hDC, hColorSpace );

                           // Draw another "blue" rectangle that 
                           // shows up as a red rectangle because
                           // of the color space.
                           //....................................
                           Rectangle( hDC, 70, 10, 110, 50 );

                           // Clean up.
                           //..........
                           SetICMMode( hDC, ICM_OFF );

                           SelectObject( hDC, hOldBrush );

                           DeleteColorSpace( hColorSpace );
                           DeleteObject( hBrush );

                           ReleaseDC( hWnd, hDC );
                        }
                        break;

                 case IDM_ABOUT :
                        DialogBox( hInst, "AboutBox", hWnd, (DLGPROC)About );
                        break;

                 case IDM_EXIT :
                        DestroyWindow( hWnd );
                        break;
              }
              break;
      
      case WM_DESTROY :
              PostQuitMessage(0);
              break;

      default :
            return( DefWindowProc( hWnd, uMsg, wParam, lParam ) );
   }

   return( 0L );
}


LRESULT CALLBACK About( HWND hDlg,           
                        UINT message,        
                        WPARAM wParam,       
                        LPARAM lParam)
{
   switch (message) 
   {
       case WM_INITDIALOG: 
               return (TRUE);

       case WM_COMMAND:                              
               if (   LOWORD(wParam) == IDOK         
                   || LOWORD(wParam) == IDCANCEL)    
               {
                       EndDialog(hDlg, TRUE);        
                       return (TRUE);
               }
               break;
   }

   return (FALSE); 
}
